<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/pathfinder.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/pathfinder.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_PATHFNDER__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_PATHFINDER__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;physicallayer/entity.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">struct </span><a class="code" href="structiPcLinearMovement.html" title="This property class controls movement of an entity in a realistic manner.">iPcLinearMovement</a>;
<a name="l00028"></a>00028 <span class="keyword">struct </span><a class="code" href="structiPcSteer.html" title="This is a steering property class.">iPcSteer</a>;
<a name="l00029"></a>00029 <span class="keyword">struct </span><a class="code" href="structiCelPath.html" title="Interface for CEL Path.">iCelPath</a>;
<a name="l00030"></a>00030 <span class="keyword">struct </span><a class="code" href="structiCelGraph.html" title="Interface for the CEL Graph.">iCelGraph</a>;
<a name="l00031"></a>00031 
<a name="l00057"></a><a class="code" href="structiPcPathFinder.html">00057</a> <span class="keyword">struct </span><a class="code" href="structiPcPathFinder.html" title="This is a pathfinder property class.">iPcPathFinder</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   SCF_INTERFACE (<a class="code" href="structiPcPathFinder.html" title="This is a pathfinder property class.">iPcPathFinder</a>, 1, 0, 0);
<a name="l00060"></a>00060 
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcPathFinder.html#a2e5a2930fde1e3109df746cd51d6cbbe" title="Move to the specified position.">Seek</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; position) = 0;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Wander (<span class="keywordtype">size_t</span> distance) = 0;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Pursue (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* target, <span class="keywordtype">float</span> max_prediction)=0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> FollowCyclicPath (<a class="code" href="structiCelPath.html" title="Interface for CEL Path.">iCelPath</a>* path)=0;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> FollowOneWayPath (<a class="code" href="structiCelPath.html" title="Interface for CEL Path.">iCelPath</a>* path)=0;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> FollowTwoWayPath (<a class="code" href="structiCelPath.html" title="Interface for CEL Path.">iCelPath</a>* path)=0;
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcPathFinder.html#a6e440b7bd3ac940a86364fc209a3f0c8" title="Interrupt a movement.">Interrupt</a> () = 0;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetDelayRecheck (<span class="keywordtype">int</span> delay) = 0;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetMinDistance (<span class="keywordtype">int</span> distance) = 0;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; GetPosition () <span class="keyword">const</span> = 0;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> StopTracking () = 0;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> IsActive () = 0;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetGraph (<a class="code" href="structiCelGraph.html" title="Interface for the CEL Graph.">iCelGraph</a>* graph) = 0;
<a name="l00110"></a>00110 };
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#endif // __CEL_PF_PATHFINDER__</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
